<?php
/*
  $Id: quantum_iframe.php V3 2023-01-13 12:53:40Z hpdl $
  Released under the GNU General Public License
  https://www.quantumgateway.com
  by
 CDG Commerce
 support@cdgcommerce.com
*/

class quantumiframe extends base {
	public $code;
  public $codeTitle;
  public $codeVersion;
	public $title;
	public $description;
	public $enabled;
	
	// class constructor
	function __construct() {
		global $order;
		
		$this->code = 'quantumiframe';
		$this->codeTitle = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_ADMIN_TITLE;
		if ($_GET['main_page'] != '') {
			$this->title = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_CATALOG_TITLE; // Payment module title in Catalog
		} else {
			$this->title = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_ADMIN_TITLE; // Payment module title in Admin
		}
		$this->description = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_DESCRIPTION;
		$this->enabled = defined('MODULE_PAYMENT_QUANTUMIFRAME_STATUS') ? ((MODULE_PAYMENT_QUANTUMIFRAME_STATUS == 'True') ?	true : false) : null;
		
		$this->sort_order = defined('MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER') ? MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER : null;
		
		if (is_object($order)) $this->update_status();

      $this->form_action_url = 'index.php?main_page=checkout_qgw_confirmation';
		#################################################
		
		#################################################
		
	}

	/**
   * Calculate zone matches and flag settings to determine whether this module should display to customers or not
   */
  function update_status() {
    global $order, $db;

    if ($this->enabled && (int)MODULE_PAYMENT_QUANTUMIFRAME_ZONE > 0 && isset($order->billing['country']['id'])) {
      $check_flag = false;
      $check = $db->Execute("SELECT zone_id FROM " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_QUANTUMIFRAME_ZONE . "' AND zone_country_id = '" . (int)$order->billing['country']['id'] . "' ORDER BY zone_id");
      while (!$check->EOF) {
        if ($check->fields['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
          $check_flag = true;
          break;
        }
        $check->MoveNext();
      }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    }

    // other status checks?
    if ($this->enabled) {
      // other checks here
    }
  }
	
	// class methods
	function javascript_validation() {
		return false;
	}
		
	function selection() {
		global $order;
		
		return array('id' => $this->code,
                   'module' => $this->public_title . (strlen(MODULE_PAYMENT_QUANTUMIFRAME_TEXT_PUBLIC_DESCRIPTION) > 0 ? ' (' . MODULE_PAYMENT_QUANTUMIFRAME_TEXT_PUBLIC_DESCRIPTION . ')' : ''));
	}
	
	function pre_confirmation_check() {
	
		return false;
	}
	
	function confirmation() {
		return false;
	}

	
	function process_button() {
		global $order, $currencies, $currency, $order, $languages_id;
		
		$process_button_string = zen_draw_hidden_field ('Amount',number_format($order->info['total'],2)) . zen_draw_hidden_field('ID', zen_session_id());
		$process_button_string .= zen_draw_hidden_field(zen_session_name(),zen_session_id());
		
		return $process_button_string;
	}
	
	function before_process() {
		global	$messageStack, $insert_id, $db;
		$approved = ($_GET['trans_result'] == "APPROVED") ? "1" : "0";
		//global $insert_id, $db;
		if ($approved == "0") {
			$comments = $_GET['decline_reason'];
			// alert to customer:
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($comments);
			$messageStack->add_session('checkout_payment', MODULE_PAYMENT_QUANTUMIFRAME_TEXT_ERROR_MESSAGE, 'caution');
			$db->Execute("UPDATE " . TABLE_ORDERS_STATUS_HISTORY . " SET comments= 'Credit Card payment.  " . $comments . " " . $this->cc_card_type . " AUTH: " . $_GET['authCode'] . ". TransID: " . $_GET['transID'] . ".', date_added=now() WHERE orders_id = '" . (int)$insert_id . "'");
			
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		}
		$auth_response = $_GET['auth_response'];
		$id = $_GET['ID'];
		$session_name = zen_session_name ();
	}
	
	function after_process() {
		return false;
	}
	
	function get_error() {
		$error = array('title' => MODULE_PAYMENT_QUANTUMIFRAME_TEXT_ERROR, 'error' => stripslashes(urldecode($_GET['error'])));
		return $error;
	}
	
	
	function check() {
		global $db;
		if (!isset($this->_check)) {
			$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_QUANTUMIFRAME_STATUS'");
			$this->_check = $check_query->RecordCount();
		}
		return $this->_check;
	}
	
	function install() {
		global $db;
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable QuantumGateway Module', 'MODULE_PAYMENT_QUANTUMIFRAME_STATUS', 'True', 'Do you want to accept QuantumGateway payments?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Username', 'MODULE_PAYMENT_QUANTUMIFRAME_APIUSERNAME', 'testing', 'API USERNAME', '6', '1', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Key', 'MODULE_PAYMENT_QUANTUMIFRAME_APIKEY', 'testing', 'API KEY', '6', '2', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Iframe Width', 'MODULE_PAYMENT_QUANTUMIFRAME_WIDTH', '800', 'FRAME WIDTH', '6', '3', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Iframe Height', 'MODULE_PAYMENT_QUANTUMIFRAME_HEIGHT', '800', 'FRAME HEIGHT', '6', '4', now())");  
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
		$db->Execute("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) VALUES ('Payment Zone', 'MODULE_PAYMENT_QUANTUMIFRAME_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
	
	}
	
	function remove() {
		global $db;
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	}
	
	function keys() {
		return array('MODULE_PAYMENT_QUANTUMIFRAME_STATUS', 
		'MODULE_PAYMENT_QUANTUMIFRAME_APIUSERNAME',
		'MODULE_PAYMENT_QUANTUMIFRAME_APIKEY',
		'MODULE_PAYMENT_QUANTUMIFRAME_WIDTH',
		'MODULE_PAYMENT_QUANTUMIFRAME_HEIGHT',
		'MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER',
		'MODULE_PAYMENT_QUANTUMIFRAME_ZONE');
	}
}
?>
